----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 05/30/2022 03:47:31 PM
-- Design Name: 
-- Module Name: tb_bram_ecc - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use std.env.finish;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity tb_bram_ecc is
--  Port ( );
end tb_bram_ecc;

architecture Behavioral of tb_bram_ecc is
component design_1_wrapper is
  port (
    addra : in STD_LOGIC_VECTOR ( 12 downto 0 );
    addrb : in STD_LOGIC_VECTOR ( 12 downto 0 );
    clka : in STD_LOGIC;
    clkb : in STD_LOGIC;
    dbiterr : out STD_LOGIC;
    dina : in STD_LOGIC_VECTOR ( 31 downto 0 );
    doutb : out STD_LOGIC_VECTOR ( 31 downto 0 );
    injectdbiterr : in STD_LOGIC;
    injectsbiterr : in STD_LOGIC;
    rdaddrecc : out STD_LOGIC_VECTOR ( 12 downto 0 );
    sbiterr : out STD_LOGIC;
    wea : in STD_LOGIC_VECTOR ( 0 to 0 )
  );
end component;
signal addra :  STD_LOGIC_VECTOR ( 12 downto 0 ):=(others=>'0');
signal addrb :  STD_LOGIC_VECTOR ( 12 downto 0 ):=(others=>'0');
signal clka :  STD_LOGIC;
signal clkb :  STD_LOGIC;
signal dbiterr :  STD_LOGIC;
signal dina :  STD_LOGIC_VECTOR ( 31 downto 0 ):=(others=>'0');
signal doutb :  STD_LOGIC_VECTOR ( 31 downto 0 );
signal injectdbiterr :  STD_LOGIC:='0';
signal injectsbiterr :  STD_LOGIC:='0';
signal rdaddrecc :  STD_LOGIC_VECTOR ( 12 downto 0 );
signal sbiterr :  STD_LOGIC;
signal wea :  STD_LOGIC_VECTOR ( 0 to 0 ):=(others=>'0');

signal  clk :  STD_LOGIC;


begin

clka<= clk;
clkb<=clk;

uut:design_1_wrapper
	port map  (	    
            addra ,
            addrb,
            clka,
            clkb,
            dbiterr,
            dina ,
            doutb ,
            injectdbiterr,
            injectsbiterr,
            rdaddrecc,
            sbiterr,
            wea
			);	


clk_gen: process is
	
	begin
	    
	    wait for 5 ns; clk <= '0'; 			-- Clock with period 10 ns
	    wait for 5 ns; clk <= '1';
	    
	end process clk_gen;

	stimuli: process is

	begin
    wait for  100 ns;
    
--------------------------------------------------------------------------------------------------------------------------------  
---- Init
--------------------------------------------------------------------------------------------------------------------------------  
    addra<="0000000000000";
    dina<=x"00000000";
 
--------------------------------------------------------------------------------------------------------------------------------  
----Fill bram addresses (0x0-0x2) with dummt data
--------------------------------------------------------------------------------------------------------------------------------  
    --write value A  to address zero
    wea<="1";
    addra<="0000000000000";
    dina<=x"0000000A";
    wait for 20 ns;
    
    --write value f to address one
    addra<="0000000000001";
    dina<=x"0000000f";
    wait for 20 ns;
    
    --write value c to address two
    addra<="0000000000010";
    dina<=x"0000000C";
    wait for 40 ns;  
--------------------------------------------------------------------------------------------------------------------------------  
----read bram addreses 0x0-0x2
--------------------------------------------------------------------------------------------------------------------------------  
    wea<="0";
    --read address zero exprected correct results
    addrb<="0000000000000";
    wait for 10 ns;
     --read address one
    addrb<="0000000000001";
    wait for 10 ns;
    --read address two
    addrb<="0000000000010";
    wait for 10 ns;
    
--------------------------------------------------------------------------------------------------------------------------------  
----inject single bit error in address 0x8
--------------------------------------------------------------------------------------------------------------------------------  
    
    --inject single bit error in address 0x8
    wea<="1";
    addra<="0000000001000";
    dina<=x"00000f0f";
    injectsbiterr<='1';
    wait for 10 ns;
    injectsbiterr<='0';
   
    --read address 0x8 expect still correct results
    wea<="0";
    addrb<="0000000001000";
    wait for 20 ns;

--------------------------------------------------------------------------------------------------------------------------------  
----inject double bit error in address 0x0
--------------------------------------------------------------------------------------------------------------------------------  
    --inject double bit error in address zero
    wea<="1";
    addra<="0000000000000";
    dina<=x"0000000A";
    injectdbiterr<='1';
    wait for 10 ns;
    injectdbiterr<='0';
    
    --read address zero expect wrong results
    wea<="0";
    addrb<="0000000000000";
    wait for 50 ns;
  --------------------------------------------------------------------------------------------------------------------------------  
   
    
    finish;
   	end process stimuli;

end Behavioral;
